package com.ruoyi.zdsz.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.annotation.DynamicName;
import com.ruoyi.common.helper.LoginHelper;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.zdsz.domain.ZEngiineeringPhoto;
import com.ruoyi.zdsz.domain.ZEngineeringNode;
import com.ruoyi.zdsz.domain.bo.ZEngiineeringPhotoBo;
import com.ruoyi.zdsz.domain.bo.ZEngineeringNodeBo;
import com.ruoyi.zdsz.domain.bo.ZFileBo;
import com.ruoyi.zdsz.domain.vo.ZEngiineeringPhotoVo;
import com.ruoyi.zdsz.domain.vo.ZEngineeringCivilVo;
import com.ruoyi.zdsz.domain.vo.ZEngineeringNodeVo;
import com.ruoyi.zdsz.service.IZEngiineeringPhotoService;
import com.ruoyi.zdsz.service.IZEngineeringNodeService;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.zdsz.domain.bo.ZEngineeringPipeJackingBo;
import com.ruoyi.zdsz.domain.vo.ZEngineeringPipeJackingVo;
import com.ruoyi.zdsz.domain.ZEngineeringPipeJacking;
import com.ruoyi.zdsz.mapper.ZEngineeringPipeJackingMapper;
import com.ruoyi.zdsz.service.IZEngineeringPipeJackingService;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;

import java.util.*;
import java.util.stream.Collectors;

/**
 * 顶管工程Service业务层处理
 *
 * @author ruoyi
 * @date 2024-01-02
 */
@RequiredArgsConstructor
@Service
public class ZEngineeringPipeJackingServiceImpl implements IZEngineeringPipeJackingService {

    private final ZEngineeringPipeJackingMapper baseMapper;

    @Autowired
    private IZEngineeringNodeService nodeService;
    @Autowired
    private IZEngiineeringPhotoService photoService;

    /**
     * 查询顶管工程
     */
    @Override
    public ZEngineeringPipeJackingVo queryById(String id){
        ZEngineeringPipeJackingVo jackingVo = baseMapper.selectVoById(id);
        ZEngiineeringPhotoBo bo1 = new ZEngiineeringPhotoBo();
        bo1.setParentId(jackingVo.getId());
        bo1.setCreateTime(jackingVo.getCreateTime());
        jackingVo.setPics(photoService.queryList(bo1));
        ZEngineeringNodeBo bo = new ZEngineeringNodeBo();
        bo.setCreateTime(jackingVo.getCreateTime());
        bo.setCivliId(jackingVo.getId());
        jackingVo.setZEngineeringNodeBoList(nodeService.queryListDetails(bo));
        return jackingVo;
    }
    /**
     * 查询顶管工程
     */
    @Override
    public ZEngineeringPipeJackingVo queryByIdType(String id,String type){
        ZEngineeringPipeJackingVo jackingVo = baseMapper.selectVoById(id);
        ZEngiineeringPhotoBo bo1 = new ZEngiineeringPhotoBo();
        bo1.setParentId(jackingVo.getId());
        bo1.setCreateTime(jackingVo.getCreateTime());
        jackingVo.setPics(photoService.queryList(bo1));
        ZEngineeringNodeBo bo = new ZEngineeringNodeBo();
        bo.setCreateTime(jackingVo.getCreateTime());
        bo.setCivliId(jackingVo.getId());
        bo.setType(type);
        jackingVo.setZEngineeringNodeBoList(nodeService.queryListDetails(bo));
        return jackingVo;
    }

    /**
     * 查询顶管工程列表
     */
    @Override
    public TableDataInfo<ZEngineeringPipeJackingVo> queryPageList(ZEngineeringPipeJackingBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ZEngineeringPipeJacking> lqw = buildQueryWrapper(bo);
        Page<ZEngineeringPipeJackingVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询顶管工程列表
     */
    @Override
    public List<ZEngineeringPipeJackingVo> queryList(ZEngineeringPipeJackingBo bo) {
        LambdaQueryWrapper<ZEngineeringPipeJacking> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ZEngineeringPipeJacking> buildQueryWrapper(ZEngineeringPipeJackingBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ZEngineeringPipeJacking> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getEnginId()), ZEngineeringPipeJacking::getEnginId, bo.getEnginId());
        lqw.like(StringUtils.isNotBlank(bo.getEnginName()), ZEngineeringPipeJacking::getEnginName, bo.getEnginName());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginAddre()), ZEngineeringPipeJacking::getEnginAddre, bo.getEnginAddre());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginCode()), ZEngineeringPipeJacking::getEnginCode, bo.getEnginCode());
        lqw.eq(StringUtils.isNotBlank(bo.getConstructUnit()), ZEngineeringPipeJacking::getConstructUnit, bo.getConstructUnit());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginScale()), ZEngineeringPipeJacking::getEnginScale, bo.getEnginScale());
        lqw.eq(StringUtils.isNotBlank(bo.getConstructQuality()), ZEngineeringPipeJacking::getConstructQuality, bo.getConstructQuality());
        lqw.eq(StringUtils.isNotBlank(bo.getConstructSchedule()), ZEngineeringPipeJacking::getConstructSchedule, bo.getConstructSchedule());
        return lqw;
    }

    /**
     * 新增顶管工程
     */
    @Transactional(rollbackFor=Exception.class)
    @Override
    public Boolean insertByBo(ZEngineeringPipeJackingBo bo) {
        ZEngineeringPipeJacking add = BeanUtil.toBean(bo, ZEngineeringPipeJacking.class);
        validEntityBeforeSave(add);
        //民用
        if ("民用工程".equals(bo.getType())){
            List<Map<String, Object>> civil = baseMapper.getCivil(bo.getEnginId());
            if (!civil.isEmpty()){
                add.setEnginAddre((String) civil.get(0).get("name"));
            }
        }
        //市政
        else if("市政工程".equals(bo.getType())){
            List<Map<String, Object>> civil = baseMapper.getSg(bo.getEnginId());
            if (!civil.isEmpty()){
                add.setEnginAddre((String) civil.get(0).get("name"));
            }
        }
        //工业
        else if("工业工程".equals(bo.getType())){
            List<Map<String, Object>> civil = baseMapper.getSg(bo.getEnginId());
            if (!civil.isEmpty()){
                add.setEnginAddre((String) civil.get(0).get("name"));
            }
        }
        // 危险
        else if("危险作业工程".equals(bo.getType())){
            List<Map<String, Object>> civil = baseMapper.getDangerous(bo.getEnginId());
            if (!civil.isEmpty()){
                add.setEnginName((String) civil.get(0).get("name"));
                add.setEnginAddre((String) civil.get(0).get("address"));
            }
        }
        //基建
        else if("基建作业工程".equals(bo.getType())){
            List<Map<String, Object>> civil = baseMapper.getInfrastructure(bo.getEnginId());
            if (!civil.isEmpty()){
                add.setEnginName((String) civil.get(0).get("name"));
                add.setEnginAddre((String) civil.get(0).get("address"));
            }
        }
        //
        LambdaQueryWrapper<ZEngineeringPipeJacking> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getEnginId()), ZEngineeringPipeJacking::getEnginId, bo.getEnginId());
        ZEngineeringPipeJackingVo jackingVo = baseMapper.selectVoOne(lqw);
        boolean flag = false;
        if (ObjectUtil.isEmpty(jackingVo)) {
            //不存在工程
            flag = baseMapper.insert(add) > 0;
            if (flag) {
                bo.setId(add.getId());
                bo.getzEngineeringNodeBo().setCivliId(add.getId());
                bo.getzEngineeringNodeBo().setCreateTime(bo.getCreateTime());
                ZEngineeringNode entity = nodeService.insert(bo.getzEngineeringNodeBo());
                if (!ObjectUtil.isEmpty(entity)){
                    List<ZEngiineeringPhoto> list = new ArrayList<>();
                    bo.getFiles().stream().forEach(o->{
                        ZEngiineeringPhoto pic = new ZEngiineeringPhoto();
                        pic.setParentId(bo.getId());
                        pic.setPicUrl(o.getUrl());
                        pic.setFileName(o.getName());
                        pic.setUpdateBy(String.valueOf(LoginHelper.getUserId()));
                        pic.setUpdateTime(new Date());
                        list.add(pic);
                    });
                    if (!list.isEmpty()) {
                        photoService.insertBatch(list);
                    }
                }
            }
        }else {
            //存在这个类型工程
            ZEngineeringNodeBo zEngineeringNodeBo = bo.getzEngineeringNodeBo();
            zEngineeringNodeBo.setCivliId(jackingVo.getId());
            zEngineeringNodeBo.setType(zEngineeringNodeBo.getType());
            zEngineeringNodeBo.setCreateTime(jackingVo.getCreateTime());
            ZEngineeringNodeBo query = nodeService.query(zEngineeringNodeBo);
            if (!ObjectUtils.isEmpty(query)) {
                zEngineeringNodeBo.setId(query.getId());
            }
            nodeService.insert(zEngineeringNodeBo);
            flag = true;
        }
        return flag;
    }

    /**
     * 修改顶管工程
     */
    @Override
    @Transactional(rollbackFor=Exception.class)
    public Boolean updateByBo(ZEngineeringPipeJackingBo bo) {
        ZEngineeringPipeJacking update = BeanUtil.toBean(bo, ZEngineeringPipeJacking.class);
        validEntityBeforeSave(update);
        //民用
        if ("民用工程".equals(bo.getType())){
            List<Map<String, Object>> civil = baseMapper.getCivil(bo.getEnginId());
            if (!civil.isEmpty()){
                update.setEnginAddre((String) civil.get(0).get("name"));
            }
        }
        //市政
        else if("市政工程".equals(bo.getType())){
            List<Map<String, Object>> civil = baseMapper.getSg(bo.getEnginId());
            if (!civil.isEmpty()){
                update.setEnginAddre((String) civil.get(0).get("name"));
            }
        }
        //工业
        else if("工业工程".equals(bo.getType())){
            List<Map<String, Object>> civil = baseMapper.getSg(bo.getEnginId());
            if (!civil.isEmpty()){
                update.setEnginAddre((String) civil.get(0).get("name"));
            }
        }
        // 危险
        else if("危险作业工程".equals(bo.getType())){
            List<Map<String, Object>> civil = baseMapper.getDangerous(bo.getEnginId());
            if (!civil.isEmpty()){
                update.setEnginName((String) civil.get(0).get("name"));
                update.setEnginAddre((String) civil.get(0).get("address"));
            }
        }
        //基建
        else if("基建作业工程".equals(bo.getType())){
            List<Map<String, Object>> civil = baseMapper.getInfrastructure(bo.getEnginId());
            if (!civil.isEmpty()){
                update.setEnginName((String) civil.get(0).get("name"));
                update.setEnginAddre((String) civil.get(0).get("address"));
            }
        }
        bo.getzEngineeringNodeBo().setCivliId(bo.getId());
        bo.getzEngineeringNodeBo().setCreateTime(bo.getCreateTime());
        nodeService.update(bo.getzEngineeringNodeBo());
        int i = baseMapper.updateById(update);
        if (i>0){
            List<ZEngiineeringPhoto> list = new ArrayList<>();

            // 查询数据库中已存在的文件列表
            ZEngiineeringPhotoBo bo1 = new ZEngiineeringPhotoBo();
            bo1.setParentId(update.getId());
            List<String> existingPhotos = photoService.queryList(bo1).stream()
                .map(ZEngiineeringPhotoVo::getPicUrl)
                .collect(Collectors.toList());

            // 插入前端传来的新文件
            for (ZFileBo pic : bo.getFiles()) {
                if (!existingPhotos.contains(pic)) {
                    ZEngiineeringPhoto newPhoto = new ZEngiineeringPhoto();
                    newPhoto.setParentId(bo.getId());
                    newPhoto.setPicUrl(pic.getUrl());
                    newPhoto.setFileName(pic.getName());
                    newPhoto.setCreateBy(String.valueOf(LoginHelper.getUserId()));
                    newPhoto.setCreateTime(new Date());
                    list.add(newPhoto);
                }
            }

            // 删除数据库中多余的文件
            List<String> photosToDelete = existingPhotos.stream()
                .filter(pic -> !bo.getFiles().contains(pic))
                .collect(Collectors.toList());
            if (!photosToDelete.isEmpty()) {
                photosToDelete.forEach(item->{
                    photoService.deleteWithValidByurls(item);
                });
            }

            // 批量插入新图片
            if (!list.isEmpty()) {
                photoService.insertBatch(list);
            }
        }
        return i>0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ZEngineeringPipeJacking entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除顶管工程
     */
    @Override
    @Transactional(rollbackFor=Exception.class)
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        ids.forEach(item -> {
            ZEngineeringPipeJackingVo vo = baseMapper.selectVoById(item);
            ZEngineeringNodeBo zEngineeringNodeBo = new ZEngineeringNodeBo();
            zEngineeringNodeBo.setCreateTime(vo.getCreateTime());
            zEngineeringNodeBo.setCivliId(vo.getId());
            List<ZEngineeringNodeBo> zEngineeringNodeBos = nodeService.queryListDetails(zEngineeringNodeBo);
            zEngineeringNodeBos.stream().forEach(ite ->
                nodeService.delete(ite)
            );
        });
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
